import { Directive, Renderer2, ElementRef, Input, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-overflow-shadow.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxOverflowShadowDirective = /** @class */ (function () {
    function NgxOverflowShadowDirective(renderer, elementRef) {
        this.renderer = renderer;
        this.elementRef = elementRef;
        this.shadowStyle = '0 0 8px 1px rgba(0, 0, 0, 0.5)';
    }
    /**
     * @return {?}
     */
    NgxOverflowShadowDirective.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var nativeElement = this.elementRef.nativeElement;
        this.observer = new IntersectionObserver(this.callback.bind(this), { root: nativeElement });
        this.createBottomPlaceholderDiv(nativeElement);
        this.createBottomShadowDiv(nativeElement);
    };
    /**
     * @return {?}
     */
    NgxOverflowShadowDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.observer.disconnect();
    };
    /**
     * @private
     * @param {?} nativeElement
     * @return {?}
     */
    NgxOverflowShadowDirective.prototype.createBottomPlaceholderDiv = /**
     * @private
     * @param {?} nativeElement
     * @return {?}
     */
    function (nativeElement) {
        /** @type {?} */
        var bottomPlaceholderDiv = this.renderer.createElement('div');
        this.renderer.appendChild(nativeElement, bottomPlaceholderDiv);
        this.observer.observe(bottomPlaceholderDiv);
    };
    /**
     * @private
     * @param {?} nativeElement
     * @return {?}
     */
    NgxOverflowShadowDirective.prototype.createBottomShadowDiv = /**
     * @private
     * @param {?} nativeElement
     * @return {?}
     */
    function (nativeElement) {
        var _this = this;
        this.bottomShadowDiv = this.renderer.createElement('div');
        Object.keys(NgxOverflowShadowDirective.DEFAULT_STYLE).forEach((/**
         * @param {?} prop
         * @return {?}
         */
        function (prop) {
            _this.renderer.setStyle(_this.bottomShadowDiv, prop, NgxOverflowShadowDirective.DEFAULT_STYLE[prop]);
        }));
        this.renderer.appendChild(nativeElement, this.bottomShadowDiv);
    };
    /**
     * @private
     * @param {?} entries
     * @return {?}
     */
    NgxOverflowShadowDirective.prototype.callback = /**
     * @private
     * @param {?} entries
     * @return {?}
     */
    function (entries) {
        /** @type {?} */
        var isIntersecting = entries.find((/**
         * @param {?} entry
         * @return {?}
         */
        function (entry) { return entry.isIntersecting; }));
        if (isIntersecting) {
            this.renderer.removeStyle(this.bottomShadowDiv, 'boxShadow');
        }
        else {
            this.renderer.setStyle(this.bottomShadowDiv, 'boxShadow', this.shadowStyle);
        }
    };
    NgxOverflowShadowDirective.DEFAULT_STYLE = {
        position: 'sticky',
        bottom: 0
    };
    NgxOverflowShadowDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxOverflowShadow]'
                },] }
    ];
    /** @nocollapse */
    NgxOverflowShadowDirective.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    NgxOverflowShadowDirective.propDecorators = {
        shadowStyle: [{ type: Input }]
    };
    return NgxOverflowShadowDirective;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NgxOverflowShadowDirective.DEFAULT_STYLE;
    /** @type {?} */
    NgxOverflowShadowDirective.prototype.shadowStyle;
    /** @type {?} */
    NgxOverflowShadowDirective.prototype.bottomShadowDiv;
    /**
     * @type {?}
     * @private
     */
    NgxOverflowShadowDirective.prototype.observer;
    /**
     * @type {?}
     * @private
     */
    NgxOverflowShadowDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NgxOverflowShadowDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-overflow-shadow.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxOverflowShadowModule = /** @class */ (function () {
    function NgxOverflowShadowModule() {
    }
    NgxOverflowShadowModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxOverflowShadowDirective],
                    exports: [NgxOverflowShadowDirective]
                },] }
    ];
    return NgxOverflowShadowModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-overflow-shadow.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxOverflowShadowDirective, NgxOverflowShadowModule };
//# sourceMappingURL=ngx-overflow-shadow.js.map
